MPQC 2.3.1

- Main Page
- Related Pages
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Classes | Public Member Functions | List of all members
sc::AtomInfo Class Reference

The AtomInfo class provides information about atoms. More...

`#include <atominfo.h>`

Inheritance diagram for sc::AtomInfo:
[legend]
Collaboration diagram for sc::AtomInfo:
[legend]

## Public Member Functions
| AtomInfo (const Ref< KeyVal > &)
| The AtomInfo KeyVal constructor is used to generate a AtomInfo object from the input. More...
| AtomInfo (StateIn &)
void | save_data_state (StateOut &s)
| Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them. More...
double | vdw_radius (int Z) const
| These return various measures of the atom's radius.
double | bragg_radius (int Z) const
double | atomic_radius (int Z) const
double | maxprob_radius (int Z) const
double | ip (int Z) const
| Returns the atomization potential for atomic number Z.
double | vdw_radius_scale () const
| Return the scale factor for the VdW radii.
double | bragg_radius_scale () const
| Return the scale factor for the Bragg radii.
double | atomic_radius_scale () const
| Return the scale factor for the atomic radii.
double | maxprob_radius_scale () const
| Return the scale factor for the maximum probability radii.
double | rgb (int Z, int color) const
| These return information about the color of the atom for visualization programs. More...
double | red (int Z) const
double | green (int Z) const
double | blue (int Z) const
double | mass (int Z) const
| This returns the mass of the most abundant isotope.
std::string | name (int Z)
| This returns the full name of the element.
std::string | symbol (int Z)
| This returns the symbol for the element.
int | string_to_Z (const std::string &, int allow_exceptions=1)
| This converts a name or symbol to the atomic number.
Public Member Functions inherited from sc::SavableState
SavableState & | operator= (const SavableState &)
void | save_state (StateOut &)
| Save the state of the object as specified by the StateOut object. More...
void | save_object_state (StateOut &)
| This can be used for saving state when the exact type of the object is known for both the save and the restore. More...
virtual void | save_vbase_state (StateOut &)
| Save the virtual bases for the object. More...
Public Member Functions inherited from sc::DescribedClass
| DescribedClass (const DescribedClass &)
DescribedClass & | operator= (const DescribedClass &)
ClassDesc * | class_desc () const throw ()
| This returns the unique pointer to the ClassDesc corresponding to the given type_info object. More...
const char * | class_name () const
| Return the name of the object's exact type.
int | class_version () const
| Return the version of the class.
virtual void | print (std::ostream &=ExEnv::out0()) const
| Print the object.
Public Member Functions inherited from sc::RefCount
int | lock_ptr () const
| Lock this object.
int | unlock_ptr () const
| Unlock this object.
void | use_locks (bool inVal)
| start and stop using locks on this object
refcount_t | nreference () const
| Return the reference count.
refcount_t | reference ()
| Increment the reference count and return the new count.
refcount_t | dereference ()
| Decrement the reference count and return the new count.
int | managed () const
void | unmanage ()
| Turn off the reference counting mechanism for this object. More...
int | managed () const
| Return 1 if the object is managed. Otherwise return 0.
Public Member Functions inherited from sc::Identity
Identifier | identifier ()
| Return the Identifier for this argument. More...

## Additional Inherited Members
Static Public Member Functions inherited from sc::SavableState
static void | save_state (SavableState *s, StateOut &)
static SavableState * | restore_state (StateIn &si)
| Restores objects saved with save_state. More...
static SavableState * | key_restore_state (StateIn &si, const char *keyword)
| Like restore_state, but keyword is used to override values while restoring. More...
static SavableState * | dir_restore_state (StateIn &si, const char *objectname, const char *keyword=0)
Protected Member Functions inherited from sc::SavableState
| SavableState (const SavableState &)
| SavableState (StateIn &)
| Each derived class StateIn CTOR handles the restore corresponding to calling save_object_state, save_vbase_state, and save_data_state listed above. More...

## Detailed Description

The AtomInfo class provides information about atoms.

The information is kept in a file named atominfo.kv in the SC library directory. That information can be overridden by the user.

## Constructor & Destructor Documentation

sc::AtomInfo::AtomInfo | ( | const Ref< KeyVal > & |  | ) |

The AtomInfo KeyVal constructor is used to generate a AtomInfo object from the input.

Default values will be read in from the `atominfo.kv` file in library directory. These can be overridden by specifying the keyword below. The library file is also read using a KeyVal constructor syntax, so consult that file for an example.

Keyword | Type | Default | Description
`mass:unit` | string | `amu` | The unit to be used for masses. See the Units class for more information about units.
`mass:`symbol | double | library value | The mass associated with the given atomic symbol.
`vdw_radius:unit` | string | `bohr` | The unit to be used for van der Waals radii. See the Units class for more information about units.
`vdw_radius:scaling_factor` | double | 1.0 | The scaling factor to be used for all van der Waals radii, including library values.
`vdw_radius:`symbol | double | library value | The van der Waals radius associated with the given atomic symbol.
`atomic_radius:unit` | string | `bohr` | The unit to be used for atomic radii. See the Units class for more information about units.
`atomic_radius:scaling_factor` | double | 1.0 | The scaling factor to be used for all atomic radii, including library values.
`atomic_radius:`symbol | double | library value | The atomic radius associated with the given atomic symbol.
`bragg_radius:unit` | string | `bohr` | The unit to be used for Bragg radii. See the Units class for more information about units.
`bragg_radius:scaling_factor` | double | 1.0 | The scaling factor to be used for all Bragg radii, including library values.
`bragg_radius:`symbol | double | library value | The Bragg radius associated with the given atomic symbol.
`maxprob_radius:unit` | string | `bohr` | The unit to be used for maximum probability radii. See the Units class for more information about units.
`maxprob_radius:scaling_factor` | double | 1.0 | The scaling factor to be used for all maximum probability radii, including library values.
`maxprob_radius:`symbol | double | library value | The maximum probability radius associated with the given atomic symbol.
`ip:unit` | string | `Hartree` | The unit to be used for ionization potentials. See the Units class for more information about units.
`ip:`symbol | double | library value | The ionization potential for the given atom.
`rgb:`symbol | double[3] | library value | A vector with the red, green, and blue values used to color each atom. Each element is between 0 (off) and 1 (on).

## Member Function Documentation

double sc::AtomInfo::rgb | ( | int | Z,
|  | int | color
| ) |  | const

These return information about the color of the atom for visualization programs.

void sc::AtomInfo::save_data_state | ( | StateOut & |  | ) |
| virtual

Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them.

This must be implemented by the derived class if the class has data.

Reimplemented from sc::SavableState.

The documentation for this class was generated from the following file:

- atominfo.h